clear; clf; clc;
set(gca,'FontSize', 16)

% Initialize sss problem

testset = 0;

%print -deps figure4.eps
sigma = 10^(-6)
ratio = 1
eps = 10^(-8);
[A, b] = testsystem(sigma, ratio);

n = size(A,1);
x_0 = zeros(n,1);
x_direct = A\b;

% solve by ssslanczos

S = A - sigma*eye(n);
[x,j,res_norm,res_hist] = mrs3(sigma,S,x_0,b,eps,1000);

disp('mrs3 norm of residual')
niter = size(res_hist,1);
err_norm = norm(x-x_direct)
%disp([niter norm(b-A*x) err_norm(niter)])

h1 = semilogy([1:niter]-1, res_hist, 'k');
set(h1,'LineWidth',2);
hold on

% solution by truncated GCR (orthomin(1))

[x,j,res_norm,res_hist]=gcr1(A,x_0,b,eps,1000);

disp(['GCR norm of residual'])
niter = size(res_hist,1);
err_norm = norm(x-x_direct)
%disp([niter norm(b-A*x) err_norm])

h3 = semilogy([1:niter]-1, res_hist, 'k--');

% solution by CGNR

[x,j,res_norm,res_hist] = cgnr(A,x_0,b,eps,1000);

disp('CGNR norm of residual')
niter = size(res_hist,1);
err_norm = norm(x-x_direct)
%disp([niter norm(b-A*x) err_norm])

h5 = semilogy(2*[1:niter]-2, res_hist, 'k:');

xlabel('matrix vector products')
ylabel('||b - A x ||')
legend([h1,h3,h5], 'MRS^3', 'GCR', 'CGNR');
axis([0 800 1e-8 1e0])
print -dpdf figure.pdf
print -deps figure.eps
