clear; clf; clc;
set(gca,'FontSize', 16)

% Initialize sss problem

sigma = 10^(-3)
ratio = 1
eps = 10^(-12);
[A, b] = testsystem(sigma, ratio);

n = size(A,1);
x_0 = zeros(n,1);
x_direct = A\b;

% solve by ssslanczos

S = A - sigma*eye(n);
[x,j,res_norm,res_hist] = mrs3(sigma,S,x_0,b,eps,1000);

disp('mrs3 norm of residual')
niter = size(res_hist,1);
err_norm = norm(x-x_direct)
%disp([niter norm(b-A*x) err_norm(niter)])

h1 = semilogy([1:niter]-1, res_hist,'k');
set(h1,'LineWidth',2);
hold on

% CGW theory

cgw_norm(1) = res_hist(1);
%niter_lan = niter;
for i = 1:niter-1
   s = res_hist(i+1)/res_hist(i);
   cgw_norm(i+1) = res_hist(i+1)/sqrt(1-s^2);
end
h7 = semilogy([1:niter]-1, cgw_norm,'ko');

% solution by CGW

[x,j,res_norm,res_hist] = cgwsss(A,x_0,b,eps,1000);

disp('CGW norm of residual')
niter = size(res_hist,1);
err_norm = norm(x-x_direct)
%disp([niter norm(b-A*x) err_norm(niter)])

h6 = semilogy([1:niter]-1, res_hist,'k');


xlabel('matrix vector products')
ylabel('||b - A x ||')
legend([h1,h6,h7], 'MRS^3', 'CGW', 'CGW theory');
%axis([0 300 1e-12 1e6])
axis([0 600 1e-12 1e6])
print -dpdf figure.pdf
print -deps figure.eps
